import 'dart:async';

import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

class ChatAnimatedMessage extends StatefulWidget {
  //Default variables
  final String message;
  //Default variables

  final Color baloonColor;
  //Default variables

  final BorderRadius roundedBorder;

  //Default variables
  final int timeToStart;

  //Default building passing props
  ChatAnimatedMessage(
      {this.message, this.baloonColor, this.timeToStart, this.roundedBorder});

  @override
  _ChatAnimatedMessageState createState() => _ChatAnimatedMessageState();
}

class _ChatAnimatedMessageState extends State<ChatAnimatedMessage>
    with TickerProviderStateMixin {
  // Color secondaryColor = Singleton().secondaryColor;
  TextStyle style = TextStyle(fontFamily: 'Montserrat', fontSize: 18.0);
  //Creating animation controller
  AnimationController _breathingController;

  //Default values of balls
  double _breathe = 0.0;
  //Default values of balls

  double _breathe2 = 0.0;
  //Default values of balls

  double _breathe3 = 0.0;

  //Default opacity valye of animated circles
  double opacityBall1 = 1;
  //Default opacity valye of animated circles

  double opacityBall2 = 0.8;
  //Default opacity valye of animated circles

  double opacityBall3 = 0.6;

  //The message that will receive letter by letter
  String message2 = "";

  //The index
  int index = 0;
  //The type variable
  bool _typing = true;

  @override
  void initState() {
    //My anim function
    animFunction();
    //Function that wait to start basead on timeToStart received
    Timer(
        Duration(milliseconds: widget.timeToStart),
        () => {
              setState(() {
                _typing = false;
              }),
              sendTextToBallon()
            });
    super.initState();
  }

  @override
  void dispose() {
    //Here i "kill" the animation
    if (_breathingController.status == AnimationStatus.forward ||
        _breathingController.status == AnimationStatus.reverse) {
      _breathingController.notifyStatusListeners(AnimationStatus.dismissed);
    }
    _breathingController.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    //Default build
    //The sizes of circles
    final size = 15.0 - 5.0 * _breathe;
    //The sizes of circles

    final size2 = 13.0 - 5.0 * _breathe2;
    //The sizes of circles

    final size3 = 11.0 - 5.0 * _breathe3;
    return Container(
      padding: EdgeInsets.only(top: 8, bottom: 8, left: 12, right: 24),
      // alignment: Alignment.centerRight,
      constraints:
          BoxConstraints(maxWidth: MediaQuery.of(context).size.width * 0.7),
      child: Container(
        // constraints: BoxConstraints(maxWidth: 250),
        padding: EdgeInsets.only(
          top: 17,
          bottom: 17,
          right: 10,
          left: 15,
        ),
        decoration: BoxDecoration(
            borderRadius: widget.roundedBorder,

            //  BorderRadius.only(
            //     // topLeft: Radius.circular(23),
            //     bottomLeft: Radius.circular(23),
            //     topRight: Radius.circular(23),
            //     bottomRight: Radius.circular(23)),
            gradient: _typing
                ? LinearGradient(colors: [Colors.grey, Colors.grey])
                : LinearGradient(
                    colors: [widget.baloonColor, widget.baloonColor])),
        child: _typing
            ? Row(
                children: <Widget>[
                  Container(
                    height: size,
                    width: size,
                    margin: EdgeInsets.only(right: 3),
                    decoration: BoxDecoration(
                        color: Colors.black.withOpacity(opacityBall1),
                        borderRadius: BorderRadius.circular(10)),
                  ),
                  Container(
                    height: size2,
                    width: size2,
                    margin: EdgeInsets.only(right: 3),
                    decoration: BoxDecoration(
                        color: Colors.black.withOpacity(opacityBall2),
                        borderRadius: BorderRadius.circular(10)),
                  ),
                  Container(
                    height: size3,
                    width: size3,
                    decoration: BoxDecoration(
                        color: Colors.black.withOpacity(opacityBall3),
                        borderRadius: BorderRadius.circular(10)),
                  )
                ],
              )
            : Text(message2,
                textAlign: TextAlign.start,
                style: TextStyle(
                    color: Colors.white,
                    fontSize: 16,
                    fontFamily: "",
                    fontWeight: FontWeight.w500)),
      ),
    );
  }

  void animFunction() {
    //Adding a controller
    _breathingController = AnimationController(
        vsync: this, duration: Duration(milliseconds: 1000));
    //Verifying if it is mounted
    if (mounted) {
      //adding an status listenner
      _breathingController.addStatusListener((status) {
        //Here a make the loop, forward and reverse
        if (status == AnimationStatus.completed) {
          if (mounted) {
            _breathingController.reverse();
          }
          // setState(() {
          //   count = count + 1;
          // });
        } else if (status == AnimationStatus.dismissed) {
          if (mounted) {
            _breathingController.forward();
          }
          // mounted ?  : null;
        } else {}
      });
    } else {
      //if is not mounted, then remove listenner
      _breathingController.removeStatusListener((status) {});
    }

    //Adding a status listenner
    _breathingController.addListener(() {
      //Using timer to make the anim
      Timer(
          Duration(milliseconds: 1),
          () => {
                mounted
                    ? setState(() {
                        _breathe = _breathingController.value - 0.30;
                        opacityBall1 = _breathingController.value;
                      })
                    : null
              });
      Timer(
          Duration(milliseconds: 5),
          () => {
                mounted
                    ? setState(() {
                        _breathe2 = _breathingController.value - 0.10;
                        opacityBall2 = _breathingController.value;
                      })
                    : null
              });
      Timer(
          Duration(milliseconds: 8),
          () => {
                mounted
                    ? setState(() {
                        _breathe3 = _breathingController.value;
                        opacityBall3 = _breathingController.value;
                      })
                    : null
              });
    });
    //Here i start the animation for the first time
    if (mounted) {
      _breathingController.forward();
    }
    // mounted ?  : null;
  }

  //This function send the text to baloon beased on the lenght of the message received
  void sendTextToBallon() {
    if (mounted) {
      setState(() {
        message2 += widget.message[index];
        index = index + 1;
      });
    }

    if (index < widget.message.length) {
      Timer(Duration(milliseconds: 50), () => sendTextToBallon());
    }
    // mounted
    //     ? setState(() {
    //         message2 += widget.message[index];
    //         index = index + 1;
    //       })
    //     : null;
    // index < widget.message.length
    //     ? Timer(Duration(milliseconds: 50), () => sendTextToBallon())
    //     : null;
  }
}
